﻿#Region "Copyright Syncfusion Inc. 2001 - 2015"
'
'  Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.IO
Imports System.Drawing.Imaging

Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.DocIO
Imports Syncfusion.DocIO.DLS
Imports System.Collections.Generic
Imports Syncfusion.Windows.Forms
Imports System.Collections.Specialized
Imports System.Diagnostics
Imports Syncfusion.Drawing
Imports Syncfusion.Pdf.Graphics
Imports Syncfusion.Pdf
Imports Syncfusion.Diagnostics
Imports Syncfusion.XlsIO
Imports Syncfusion.GridExcelConverter
Imports Syncfusion.GridHelperClasses
Imports System.Text



Namespace ExportingDemo
	Public Class Form1
		Inherits Form

		#Region "API Definition"
		Private WithEvents gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
		Private panel1 As System.Windows.Forms.Panel
		Private WithEvents button1 As Button
		Private components As IContainer
		#End Region

		#Region "Constructor"
		Public Sub New()
			InitializeComponent()
			Me.gridControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro
		   ' this.gridControl1.AllowProportionalColumnSizing = true;
			Dim model As GridModel = gridControl1.Model
			model.Options.FloatCellsMode = GridFloatCellsMode.OnDemandCalculation
			Dim boldFont As New GridFontInfo()
			boldFont.Bold = True
			boldFont.Size = 10
			boldFont.Underline = True
			gridControl1.Rows.DefaultSize += 2
			Dim boldfontRowHeight As Integer = gridControl1.Rows.DefaultSize + 6

			model.Options.ControllerOptions = GridControllerOptions.All
			model.Options.DataObjectConsumerOptions = GridDataObjectConsumerOptions.All
			Dim standard As GridStyleInfo = model.BaseStylesMap("Standard").StyleInfo
			Dim header As GridStyleInfo = model.BaseStylesMap("Header").StyleInfo
			Dim rowHeader As GridStyleInfo = model.BaseStylesMap("Row Header").StyleInfo
			Dim colHeader As GridStyleInfo = model.BaseStylesMap("Column Header").StyleInfo
			header.Interior = New BrushInfo(SystemColors.Control)
			rowHeader.Interior = New BrushInfo(SystemColors.Control)
			standard.Font.Facename = "Helvetica"
			standard.VerticalAlignment = GridVerticalAlignment.Middle
			Me.gridControl1.RowCount = 50
		End Sub

		#End Region                      

		#Region "Desginer Stuffs"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim gridBaseStyle1 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle2 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle3 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridBaseStyle4 As New Syncfusion.Windows.Forms.Grid.GridBaseStyle()
			Dim gridCellInfo1 As New Syncfusion.Windows.Forms.Grid.GridCellInfo()
			Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl()
			Me.panel1 = New System.Windows.Forms.Panel()
			Me.button1 = New System.Windows.Forms.Button()
			DirectCast(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
			Me.panel1.SuspendLayout()
			Me.SuspendLayout()
			' 
			' gridControl1
			' 
			Me.gridControl1.AlphaBlendSelectionColor = System.Drawing.Color.FromArgb((CInt((CByte(64)))), (CInt((CByte(94)))), (CInt((CByte(171)))), (CInt((CByte(222)))))
			gridBaseStyle1.Name = "Header"
			gridBaseStyle1.StyleInfo.CellType = "Header"
			gridBaseStyle1.StyleInfo.Font.Bold = True
			gridBaseStyle1.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb((CInt((CByte(203)))), (CInt((CByte(199)))), (CInt((CByte(184))))), System.Drawing.Color.FromArgb((CInt((CByte(238)))), (CInt((CByte(234)))), (CInt((CByte(216))))))
			gridBaseStyle1.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle
			gridBaseStyle2.Name = "Standard"
			gridBaseStyle2.StyleInfo.Font.Facename = "Tahoma"
			gridBaseStyle2.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Window)
			gridBaseStyle3.Name = "Column Header"
			gridBaseStyle3.StyleInfo.BaseStyle = "Header"
			gridBaseStyle3.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center
			gridBaseStyle3.StyleInfo.TextColor = System.Drawing.Color.Black
			gridBaseStyle4.Name = "Row Header"
			gridBaseStyle4.StyleInfo.BaseStyle = "Header"
			gridBaseStyle4.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left
			gridBaseStyle4.StyleInfo.Interior = New Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb((CInt((CByte(203)))), (CInt((CByte(199)))), (CInt((CByte(184))))), System.Drawing.Color.FromArgb((CInt((CByte(238)))), (CInt((CByte(234)))), (CInt((CByte(216))))))
			Me.gridControl1.BaseStylesMap.AddRange(New Syncfusion.Windows.Forms.Grid.GridBaseStyle() { gridBaseStyle1, gridBaseStyle2, gridBaseStyle3, gridBaseStyle4})
			Me.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.gridControl1.ColCount = 9
			Me.gridControl1.ColWidthEntries.AddRange(New Syncfusion.Windows.Forms.Grid.GridColWidth() {
				New Syncfusion.Windows.Forms.Grid.GridColWidth(0, 35),
				New Syncfusion.Windows.Forms.Grid.GridColWidth(3, 179),
				New Syncfusion.Windows.Forms.Grid.GridColWidth(4, 196)
			})
			Me.gridControl1.DefaultColWidth = 70
			Me.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid
			Me.gridControl1.DefaultRowHeight = 20
			Me.gridControl1.Dock = System.Windows.Forms.DockStyle.Fill
			Me.gridControl1.Font = New System.Drawing.Font("Segoe UI", 8.5F)
			Me.gridControl1.ForeColor = System.Drawing.Color.MidnightBlue
			gridCellInfo1.Col = -1
			gridCellInfo1.Row = -1
			gridCellInfo1.StyleInfo.Font.Bold = False
			gridCellInfo1.StyleInfo.Font.Facename = "Segoe UI"
			gridCellInfo1.StyleInfo.Font.Italic = False
			gridCellInfo1.StyleInfo.Font.Size = 8.5F
			gridCellInfo1.StyleInfo.Font.Strikeout = False
			gridCellInfo1.StyleInfo.Font.Underline = False
			gridCellInfo1.StyleInfo.Font.Unit = System.Drawing.GraphicsUnit.Point
			Me.gridControl1.GridCells.AddRange(New Syncfusion.Windows.Forms.Grid.GridCellInfo() { gridCellInfo1})
			Me.gridControl1.GridOfficeScrollBars = Syncfusion.Windows.Forms.OfficeScrollBars.Metro
			Me.gridControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro
			Me.gridControl1.HorizontalThumbTrack = True
			Me.gridControl1.Location = New System.Drawing.Point(0, 0)
			Me.gridControl1.MetroScrollBars = True
			Me.gridControl1.Name = "gridControl1"
			Me.gridControl1.Properties.BackgroundColor = System.Drawing.Color.White
			Me.gridControl1.Properties.ForceImmediateRepaint = False
			Me.gridControl1.Properties.GridLineColor = System.Drawing.Color.FromArgb((CInt((CByte(208)))), (CInt((CByte(215)))), (CInt((CByte(229)))))
			Me.gridControl1.Properties.MarkColHeader = False
			Me.gridControl1.Properties.MarkRowHeader = False
			Me.gridControl1.RightToLeft = System.Windows.Forms.RightToLeft.No
			Me.gridControl1.RowCount = 30
			Me.gridControl1.RowHeightEntries.AddRange(New Syncfusion.Windows.Forms.Grid.GridRowHeight() { New Syncfusion.Windows.Forms.Grid.GridRowHeight(0, 21)})
			Me.gridControl1.SerializeCellsBehavior = Syncfusion.Windows.Forms.Grid.GridSerializeCellsBehavior.SerializeIntoCode
			Me.gridControl1.Size = New System.Drawing.Size(772, 468)
			Me.gridControl1.SmartSizeBox = False
			Me.gridControl1.TabIndex = 3
			Me.gridControl1.ThemesEnabled = True
			Me.gridControl1.VerticalThumbTrack = True
'INSTANT VB NOTE: The following InitializeComponent event wireup was converted to a 'Handles' clause:
'ORIGINAL LINE: this.gridControl1.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridControl1_SaveCellText);
'INSTANT VB NOTE: The following InitializeComponent event wireup was converted to a 'Handles' clause:
'ORIGINAL LINE: this.gridControl1.SaveCellFormattedText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridControl1_SaveCellFormattedText);
			' 
			' panel1
			' 
			Me.panel1.Anchor = (CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles))
			Me.panel1.BackColor = System.Drawing.Color.White
			Me.panel1.Controls.Add(Me.button1)
			Me.panel1.Controls.Add(Me.gridControl1)
			Me.panel1.Location = New System.Drawing.Point(0, 0)
			Me.panel1.Name = "panel1"
			Me.panel1.Size = New System.Drawing.Size(772, 468)
			Me.panel1.TabIndex = 4
			' 
			' button1
			' 
			Me.button1.Location = New System.Drawing.Point(643, 424)
			Me.button1.Name = "button1"
			Me.button1.Size = New System.Drawing.Size(107, 32)
			Me.button1.TabIndex = 4
			Me.button1.Text = "Export"
			Me.button1.UseVisualStyleBackColor = True
'INSTANT VB NOTE: The following InitializeComponent event wireup was converted to a 'Handles' clause:
'ORIGINAL LINE: this.button1.Click += new System.EventHandler(this.button1_Click);
			' 
			' Form1
			' 
			Me.ClientSize = New System.Drawing.Size(784, 468)
			Me.Controls.Add(Me.panel1)
			Me.MinimumSize = New System.Drawing.Size(800, 400)
			Me.Name = "Form1"
			Me.Text = "Exporting"
'INSTANT VB NOTE: The following InitializeComponent event wireup was converted to a 'Handles' clause:
'ORIGINAL LINE: this.Load += new System.EventHandler(this.Form1_Load);
			DirectCast(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
			Me.panel1.ResumeLayout(False)
			Me.ResumeLayout(False)

		End Sub
		Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
			Dim ToolTip1 As New System.Windows.Forms.ToolTip()
			Me.PopulateTheGridExcel()
			Me.gridControl1.TableStyle.TextColor = Color.DimGray
		End Sub
		#Region "Dispose"
		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If components IsNot Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub
		#End Region
		#End Region

		#Region "Main"
		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread>
		Public Shared Sub Main()
			#If SyncfusionFramework1_1 OrElse SyncfusionFramework2_0 Then
			Application.EnableVisualStyles()
			  #End If
			Application.Run(New Form1())
		End Sub
		#End Region

		#Region "Methods"

		Private Function RandomString(ByVal r As Random) As String
			Dim len As Integer = r.Next(12) + 1
			Dim sb As New System.Text.StringBuilder(len)

			For i As Integer = 0 To len - 1
				sb.Append(ChrW(r.Next(26) + 65))
			Next i

			Return sb.ToString()
		End Function
		Private Sub populateTheGridWord()
			Me.gridControl1.SuspendLayout()
			Dim rand As New Random()
			For i As Integer = 1 To gridControl1.RowCount
				For j As Integer = 1 To gridControl1.ColCount
					Me.gridControl1(i, j).Text = (10 * (i * j)).ToString()
					Me.gridControl1(0, j).Text = "C" & j.ToString()
					Me.gridControl1(i, 0).Text = "R" & i.ToString()
				Next j
			Next i

			'this.gridControl1.AllowProportionalColumnSizing = true;
			Me.gridControl1.ResumeLayout()
		End Sub
		Private Sub PopulateTheGridHtml()
			Me.gridControl1.SuspendLayout()
		   ' gridControl1.Model.ColStyles[1].TextColor = Color.MidnightBlue;
			gridControl1.Model.ColStyles(1).Font.Size = 30
			gridControl1.Model.ColStyles(3).VerticalAlignment = GridVerticalAlignment.Middle
			gridControl1.Model.ColStyles(3).HorizontalAlignment = GridHorizontalAlignment.Right
			gridControl1.Model.ColStyles(3).TextColor = Color.Red
			gridControl1.Model.ColStyles(3).Font.Bold = True
			gridControl1.Model.ColStyles(4).CellType = GridCellTypeName.CheckBox

			gridControl1.Model.ColStyles(5).Borders.All = New GridBorder(GridBorderStyle.Solid)
			gridControl1.Model.ColStyles(5).CellType = GridCellTypeName.RadioButton
			gridControl1.Model.ColStyles(5).ChoiceList = New System.Collections.Specialized.StringCollection()
			gridControl1.Model.ColStyles(5).ChoiceList.AddRange(New String() { "one", "two" })

			gridControl1.Model.ColWidths(1) = 180
			gridControl1.Model.ColWidths(5) = 110
			gridControl1.Model.RowHeights(1) = 80

			gridControl1(1, 1).Text = "Size"
			gridControl1(1, 3).Text = "Align"

			gridControl1.Model.ColStyles(7).CellType = GridCellTypeName.ComboBox
			gridControl1.Model.ColStyles(7).ChoiceList = Me.gridControl1.Model.ColStyles(5).ChoiceList
		   ' this.gridControl1.AllowProportionalColumnSizing = true;
			Me.gridControl1.ResumeLayout()
		End Sub
		Private Sub PopulateTheGridPdf()
			Me.gridControl1.SuspendLayout()
			Dim r As New Random()
			Me.gridControl1.CommandStack.Enabled = False
			For row As Integer = 1 To Me.gridControl1.RowCount
				For col As Integer = 1 To Me.gridControl1.ColCount
					If col = 2 Then 'datetime col
						Dim dt As New Date(r.Next(50) + 1960, r.Next(11) + 1, r.Next(27) + 1)
						Me.gridControl1(row, col).CellValue = dt
					ElseIf col = 4 OrElse col = 5 Then 'formula col and text col
						If col = 5 Then
							Me.gridControl1(row, col).CellValue = RandomString(r)
						End If
					ElseIf col = 6 Then 'float
						Me.gridControl1(row, col).CellValue = (If(r.Next(2) = 0, 1, -1)) * (CSng(r.Next(100000))) / 200
					ElseIf col = 3 Then 'int count col
						Me.gridControl1(row, col).CellValue = row
					Else 'int
						Me.gridControl1(row, col).CellValue = (If(r.Next(2) = 0, 1, -1)) * r.Next(1000)
					End If
				Next col
			Next row
			Me.gridControl1.DefaultColWidth = 50

			If gridControl1.ColCount >= 1 Then
				Me.gridControl1.ColStyles(1).BackColor = Color.White
			End If
			'column 2 is a date column
			If gridControl1.ColCount >= 2 Then
				Me.gridControl1.ColStyles(2).CellValueType = GetType(Date)
				Me.gridControl1.ColStyles(2).Format = "dd MMM yyyy"
				Me.gridControl1.ColWidths(2) = 100
				Me.gridControl1(0, 2).Text = "Date"
				Me.gridControl1.ColStyles(2).BackColor = Color.FromArgb(237, 240, 246)
				Me.gridControl1.ColStyles(3).BackColor = Color.FromArgb(218, 229, 245)
			End If
			'column 4 is formula col which used relative notation (row = 0)
			'to enter the formulas as a simgle string as the default value
			'in the column
			If gridControl1.ColCount >= 4 Then
				Me.gridControl1.ColWidths(4) = 100
				Me.gridControl1(0, 4).Text = "FormulaCell"
				Me.gridControl1.ColStyles(4).CellType = "FormulaCell"
				Me.gridControl1.ColStyles(4).Text = "= A0 + C0"
				Me.gridControl1.ColStyles(4).BackColor = Color.FromArgb(218, 229, 245) 'row = 0 means use current row
			End If

			'col 6 is a text column
			If gridControl1.ColCount >= 5 Then
				Me.gridControl1.ColWidths(5) = 100
				Me.gridControl1(0, 5).Text = "Text"
				Me.gridControl1.ColStyles(5).BackColor = Color.FromArgb(102, 110, 152)
				Me.gridControl1.ColStyles(5).TextColor = Color.White
			End If

			'column 6 is a float column
			If gridControl1.ColCount >= 6 Then
				Me.gridControl1.ColStyles(6).CellValueType = GetType(Single)
				Me.gridControl1.ColStyles(6).Format = "####.##"
				Me.gridControl1.ColWidths(6) = 100
				Me.gridControl1(0, 6).Text = "floats"
				Me.gridControl1.ColStyles(6).BackColor = Color.FromArgb(252, 172, 38)
			End If
			'force the entire column to be computed, not just the visible cells
			'so if sort is done on formula column, all cells will have been computed.
			Dim engine As GridFormulaEngine = CType(Me.gridControl1.CellModels("FormulaCell"), GridFormulaCellModel).Engine
			engine.RecalculateRange(GridRangeInfo.Col(4), True, True)

			If gridControl1.ColCount >= 10 Then
				Me.gridControl1.ColStyles(7).BackColor = Color.FromArgb(255, 153, 51)
				Me.gridControl1.ColStyles(8).BackColor = Color.FromArgb(238, 122, 3)
				Me.gridControl1.ColStyles(9).BackColor = Color.FromArgb(238, 122, 3)
				Me.gridControl1.ColStyles(10).BackColor = Color.FromArgb(&Hde, &H64, &H13)
				Me.gridControl1.ColStyles(10).TextColor = Color.White
			End If

			Me.gridControl1.DefaultRowHeight = 18
			Me.gridControl1.DefaultColWidth = 70
			Me.gridControl1.Properties.GridLineColor = System.Drawing.Color.Silver
			Me.gridControl1.DefaultGridBorderStyle = GridBorderStyle.Solid
		   ' this.gridControl1.AllowProportionalColumnSizing = true;
			Me.gridControl1.ResumeLayout()

		End Sub
		Private Sub PopulateTheGridExcel()
			Me.gridControl1.SuspendLayout()
			Dim boldFont As New GridFontInfo()
			boldFont.Bold = True
			boldFont.Size = 11
			boldFont.Underline = True

			Dim rowIndex As Integer = 2
			Dim colIndex As Integer = 1

			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "TextColor"
			gridControl1(rowIndex, 1).Font = boldFont
			rowIndex += 1

			colIndex = 1
			For Each color As Color In New Color() { System.Drawing.Color.Black, System.Drawing.Color.Red, System.Drawing.Color.Blue, System.Drawing.Color.Green, System.Drawing.Color.Yellow, System.Drawing.Color.DimGray}
				gridControl1(rowIndex, colIndex).TextColor = color
				gridControl1(rowIndex, colIndex).Text = ColorConvert.ColorToString(color, True)
				colIndex += 1
			Next color
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Rows(rowIndex - 1, rowIndex))
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "BackColor"
			gridControl1(rowIndex, 1).Font = boldFont
			rowIndex += 1

			colIndex = 1
			For Each color As Color In New Color() { SystemColors.ActiveCaptionText, System.Drawing.Color.Red, System.Drawing.Color.Blue, System.Drawing.Color.Green, System.Drawing.Color.Yellow, System.Drawing.Color.Black}
				gridControl1(rowIndex, colIndex).TextColor = System.Drawing.Color.White
				gridControl1(rowIndex, colIndex).BackColor = color
				gridControl1(rowIndex, colIndex).Text = ColorConvert.ColorToString(color, True)
				colIndex += 1
			Next color
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Rows(rowIndex - 1, rowIndex))
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "Font"
			gridControl1(rowIndex, 1).Font = boldFont
			rowIndex += 1

'INSTANT VB NOTE: The variable size was renamed since Visual Basic does not handle local variables named the same as class members well:
			For Each size_Renamed As Integer In New Integer(){ 6, 7, 8, 10, 12, 14}
				gridControl1(rowIndex, colIndex).Font.Size = size_Renamed
				gridControl1(rowIndex, colIndex).Text = size_Renamed.ToString()
				colIndex += 1
			Next size_Renamed
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Rows(rowIndex - 1, rowIndex))

			rowIndex += 1
			colIndex = 1
			For Each fontStyle As FontStyle In New FontStyle() { System.Drawing.FontStyle.Bold, System.Drawing.FontStyle.Italic, System.Drawing.FontStyle.Regular, System.Drawing.FontStyle.Strikeout, System.Drawing.FontStyle.Underline, System.Drawing.FontStyle.Bold Or System.Drawing.FontStyle.Italic Or System.Drawing.FontStyle.Regular}
				gridControl1(rowIndex, colIndex).Font.FontStyle = fontStyle
				gridControl1(rowIndex, colIndex).Text = System.Enum.Format(GetType(FontStyle), fontStyle, "G")
				colIndex += 1
			Next fontStyle

			rowIndex += 1
			colIndex = 1
			For Each facename As String In New String() { "Comic Sans MS", "Arial", "Century", "Courier New", "Times New Roman", "Verdana"}
				gridControl1(rowIndex, colIndex).Font.Facename = facename
				gridControl1(rowIndex, colIndex).Text = facename
				colIndex += 1
			Next facename
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "Alignment"
			gridControl1(rowIndex, 1).Font = boldFont
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			gridControl1(rowIndex, colIndex).HorizontalAlignment = GridHorizontalAlignment.Left
			gridControl1(rowIndex, colIndex).VerticalAlignment = GridVerticalAlignment.Top
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, colIndex, rowIndex, colIndex + 1))
			gridControl1(rowIndex, colIndex).Text = "Top Left"
			gridControl1.RowHeights(rowIndex) = 30
			colIndex += 2

			gridControl1(rowIndex, colIndex).HorizontalAlignment = GridHorizontalAlignment.Center
			gridControl1(rowIndex, colIndex).VerticalAlignment = GridVerticalAlignment.Middle
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, colIndex, rowIndex, colIndex + 1))
			gridControl1(rowIndex, colIndex).Text = "Center"
			colIndex += 2

			gridControl1(rowIndex, colIndex).HorizontalAlignment = GridHorizontalAlignment.Right
			gridControl1(rowIndex, colIndex).VerticalAlignment = GridVerticalAlignment.Bottom
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, colIndex, rowIndex, colIndex + 1))
			gridControl1(rowIndex, colIndex).Text = "Bottom Right"
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "Orientation"
			gridControl1(rowIndex, 1).Font = boldFont
			rowIndex += 1

			For Each orientation As Integer In New Integer() { 0, 30, 45, 60, 90, 270}
				Dim style1 As GridStyleInfo = gridControl1(rowIndex, colIndex)
				style1.HorizontalAlignment = GridHorizontalAlignment.Center
				style1.VerticalAlignment = GridVerticalAlignment.Middle
'INSTANT VB NOTE: The variable font was renamed since Visual Basic does not handle local variables named the same as class members well:
				Dim font_Renamed As GridFontInfo = style1.Font
				font_Renamed.Orientation = orientation
				font_Renamed.Bold = True
				style1.Text = "Angle = " & font_Renamed.Orientation.ToString()
				colIndex += 1
			Next orientation
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "Formula Cell"
			gridControl1(rowIndex, 1).Font = boldFont
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			Dim r As New Random()
			Do While colIndex <= 5
				gridControl1(rowIndex, colIndex).CellValue = r.Next(500)
				colIndex += 1
			Loop
			gridControl1(rowIndex, colIndex).CellType = "FormulaCell"
			gridControl1(rowIndex, colIndex).Text = "=SUM(A" & rowIndex & ":" & "E" & rowIndex & ")"

			gridControl1(rowIndex, colIndex).Borders.All = New GridBorder(GridBorderStyle.Solid, Color.Red, GridBorderWeight.ExtraExtraThick)
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			rowIndex += 1
			colIndex = 1
			gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
			gridControl1(rowIndex, 1).Text = "Currency Cell"
			gridControl1(rowIndex, 1).Font = boldFont
			gridControl1.RowHeights.ResizeToFit(GridRangeInfo.Row(rowIndex))
			rowIndex += 1

			Do While colIndex <= 6
				gridControl1(rowIndex, colIndex).CellType = "Currency"
				gridControl1(rowIndex, colIndex).CurrencyEdit.NegativeColor = Color.Black
				gridControl1(rowIndex, colIndex).CurrencyEdit.CurrencyNegativePattern = 2
				gridControl1(rowIndex, colIndex).CellValue = r.Next(-100, 100)
				colIndex += 1
			Loop
			Me.gridControl1.Properties.GridLineColor = Color.FromArgb(208, 215, 229)
			Dim style As GridStyleInfo = gridControl1.BaseStylesMap("Header").StyleInfo
					  style.Font.Facename = "Verdana"
			Me.BackColor = Color.White
			Me.StartPosition = FormStartPosition.CenterScreen
			'this.gridControl1.AllowProportionalColumnSizing = true;
			Me.gridControl1.ResumeLayout()
		End Sub


		Private Sub gridControl1_SaveCellText(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs) Handles gridControl1.SaveCellText
			TraceUtil.TraceCurrentMethodInfo(e)
			ParseText(e)
		End Sub

		Private Sub gridControl1_SaveCellFormattedText(ByVal sender As Object, ByVal e As GridCellTextEventArgs) Handles gridControl1.SaveCellFormattedText
			TraceUtil.TraceCurrentMethodInfo(e)
			ParseText(e)
		End Sub

		Private Sub ParseText(ByVal e As GridCellTextEventArgs)
			' By default, the grid will display a warning message box informing the user
			' the entered value is not valid and the user will have to change the value.
			'
			' In this event handler we change the grid defaults behavior such that
			' when the user enters a value that does not fit the cells CellValueType,
			' the input text is accepted and no warning message is shown.
			If e.Handled OrElse e.Style.Tag Is Nothing OrElse Not e.Style.Tag.Equals("Custom") Then
				Return
			End If

			Dim ci As System.Globalization.CultureInfo = e.Style.CultureInfo
			Dim nfi As System.Globalization.NumberFormatInfo = If(ci IsNot Nothing, ci.NumberFormat, Nothing)
			Try
				e.Style.CellValue = GridCellValueConvert.Parse(e.Text, e.Style.CellValueType, nfi, e.Style.Format)
			Catch ex As Exception
				If TypeOf ex Is FormatException OrElse TypeOf ex.InnerException Is FormatException Then
					e.Style.CellValue = e.Text
					' possibly could also change CellValueType here 
					e.Style.CellValueType = GetType(String)
					Console.WriteLine("Changed e.Style.CellValueType = typeof(string) for " & e.Style.Identity.ToString())
					' - or -
					' you could also further analyze the input text and assign a type
					' that fits the input text, e.g.
					' e.Style.CellValueType = typeof(datetime);
					' - or - 
					' e.Style.CellValueType = typeof(decimal);
					' etc.
				Else
					Throw
				End If
			End Try
			e.Handled = True
		End Sub
		#End Region


		#Region "Excel"

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			Dim gecc As New Syncfusion.GridExcelConverter.GridExcelConverterControl()
			AddHandler gecc.QueryImportExportCellInfo, AddressOf gecc_QueryImportExportCellInfo
			Dim saveFileDialog As New SaveFileDialog()
			saveFileDialog.Filter = "Files(*.xls)|*.xls"
			saveFileDialog.DefaultExt = ".xls"

			If saveFileDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
				gecc.GridToExcel(Me.gridControl1.Model, saveFileDialog.FileName)

				If MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = System.Windows.Forms.DialogResult.Yes Then
					Dim proc As New Process()
					proc.StartInfo.FileName = saveFileDialog.FileName
					proc.Start()
				End If
			End If
		End Sub

		Private Sub gecc_QueryImportExportCellInfo(ByVal sender As Object, ByVal e As GridImportExportCellInfoEventArgs)
			If e.Action = GridConverterAction.Export Then
				If e.GridCell.CellType = GridCellTypeName.FormulaCell AndAlso e.GridCell.HasFormulaTag Then
					e.ExcelCell.Value = e.GridCell.FormattedText
					e.Handled = True
				End If
			End If
		End Sub
		#End Region        

	End Class
End Namespace
